<?php
defined('_JEXEC') or die();
/**
 *
 * @package	VirtueMart
 * @subpackage Plugins  - Fields
 * @author Reinhold Kainhofer, Open Tools
 * @link http://www.open-tools.net
 * @copyright Copyright (c) 2014 Reinhold Kainhofer. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 */
 
defined('DS') or define('DS', DIRECTORY_SEPARATOR);

class JFormFieldVmOrdernumberCounters extends JFormField {
    var $_name = 'vmOrdernumberCounters';
    
    protected $countertype;

	public function __get($name)
	{
		switch ($name)
		{
			case 'countertype':
				return $this->$name;
		}

		return parent::__get($name);
	}

	public function __set($name, $value)
	{
		switch ($name)
		{
			case 'countertype':
				$this->$name = (string) $value;
				break;

			default:
				parent::__set($name, $value);
		}
	}

	public function setup(SimpleXMLElement $element, $value, $group = null)
	{
		$return = parent::setup($element, $value, $group);

		if ($return) {
			$this->countertype  = (string) $this->element['countertype'];
		}

		return $return;
	}
	
    protected function getInput() {
        // Look up the current counters
        $db = JFactory::getDBO();
        $db->setQuery('SELECT `number_format`, `count` FROM `#__virtuemart_shopper_plg_ordernumber` WHERE `number_type`='.(string)$this->countertype . ' ORDER BY `number_format`;' );
        $counters = $db->loadObjectList();
// JFactory::getApplication()->enqueueMessage("<pre>All counters: ".print_r($counters, 1)."</pre>", 'error');
        // Joomla 2.x uses <li> for the params and float:left on the controls, so we need to add that too
        $version = new JVersion();
        $float = "";
        if (version_compare(JVERSION, '3.0', 'lt')) {
            $float = "float: left; ";
        }
        
        $ret = "<table border=\"1\" style=\"border: 1px solid dark-gray; border-collapse: collapse; display: inline-table; $float\"><tr><th>".JText::_('PLG_ORDERNUMBER_COUNTERLIST_HEADER_COUNTER')."</th><th>".JText::_('PLG_ORDERNUMBER_COUNTERLIST_HEADER_VALUE'). "</th></tr>";
        $ret .= "<colgroup><col ><col style=\"text-align: center\" ></colgroup>";
        foreach ($counters as $c) {
            if ($c->number_format=="") {
                $c->number_format = JText::_ ('PLG_ORDERNUMBER_COUNTERLIST_GLOBAL');
            }
            $ret .= "<tr><td>" . (string)$c->number_format . "</td><td>" . (string)$c->count . "</td></tr>";
        }
        $ret .= "</table>";
        return $ret;
    }
}